import ReactDOM from 'react-dom';
import makeKeyframes from './animations/make.keyframes';
import { animations, characters } from './constants';
export function generateHashStringByLength(length) {
    if (length === void 0) { length = 6; }
    var result = [];
    var charactersLength = characters.length;
    for (var i = 0; i < length; i++) {
        result.push(characters.charAt(Math.floor(Math.random() * charactersLength)));
    }
    return result.join('');
}
export function findDivByRef(element) {
    return ReactDOM.findDOMNode(element);
}
export function getAnimationType(path) {
    return animations[path];
}
var makeTimeToMillisecondString = function (number) { return number + "ms"; };
export function setShowAnimation(element, duration, delay, path) {
    element.style.animationDuration = makeTimeToMillisecondString(duration);
    element.style.animationDelay = makeTimeToMillisecondString(delay);
    element.style.animationName = getAnimationType(path);
}
export var endShowAnimation = function (element) { return function () {
    element.style.opacity = '1';
}; };
export function setHideAnimation(element, duration, delay, path) {
    element.style.animationDuration = makeTimeToMillisecondString(duration);
    element.style.animationDelay = makeTimeToMillisecondString(delay);
    element.style.animationName = getAnimationType(path);
    element.style.animationDirection = 'reverse';
}
export var endHideAnimation = function (element) { return function () {
    element.style.opacity = '0';
}; };
var isCreated = false;
export function createKeyframes() {
    if (!isCreated)
        isCreated = true;
    else
        return;
    var style = document.createElement('style');
    style.type = 'text/css';
    var keyFrames = makeKeyframes();
    style.innerHTML = keyFrames;
    document.getElementsByTagName('head')[0].appendChild(style);
}
//# sourceMappingURL=functions.js.map